package com.example.dao.house;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.example.entity.house.HouseBuildingHighRepairPo;
import com.example.entity.house.HouseBuildingSameRepairFrequencyPo;
import com.example.pojo.bo.ListBuildingHighRepairBo;
import com.example.pojo.bo.ListBuildingSameRepairFrequencyBo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface HouseRepairExceptionDao {
    /**
     * 查询不动产自有房产维修高总价统计
     */
    @Select("""
<script>
select
*
from house.building_high_repair
<where>
  <choose>
    <when test="dto.yearMonth != null">
      year_month = #{dto.yearMonth}
    </when>
    <otherwise>
      year_month = (select max(year_month) from house.building_high_repair)
    </otherwise>
  </choose>
  <if test="dto.areaNo != null and dto.areaNo != ''">
    and area_no = #{dto.areaNo}
  </if>
  <if test="dto.cityNo != null and dto.cityNo != ''">
    and city_no = #{dto.cityNo}
  </if>
</where>
</script>
""")
    List<HouseBuildingHighRepairPo> listBuildingHighRepair(Page<HouseBuildingHighRepairPo> page,
                                                           @Param("dto") ListBuildingHighRepairBo dto);

    /**
     * 查询不动产自有房产相同维修频次统计
     */
    @Select("""
<script>
select
*
from house.building_same_repair_frequency
<where>
  <choose>
    <when test="dto.yearMonth != null">
      year_month = #{dto.yearMonth}
    </when>
    <otherwise>
      year_month = (select max(year_month) from house.building_same_repair_frequency)
    </otherwise>
  </choose>
  <if test="dto.areaNo != null and dto.areaNo != ''">
    and area_no = #{dto.areaNo}
  </if>
  <if test="dto.cityNo != null and dto.cityNo != ''">
    and city_no = #{dto.cityNo}
  </if>
</where>
</script>
""")
    List<HouseBuildingSameRepairFrequencyPo> listBuildingSameRepairFrequency(
            Page<HouseBuildingSameRepairFrequencyPo> page,
            @Param("dto") ListBuildingSameRepairFrequencyBo dto);
}
